﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Windows.Forms;

namespace UploadFileToHost
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnAddFile_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Multiselect = true;
            ofd.Title = "فایل ها را جهت آپلود به هاست انتخاب کنید";
            ofd.Filter = "همه فایل ها (*.*)|*.*";
            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                foreach (var item in ofd.FileNames)
                {
                    richTextBox1.Text += item + Environment.NewLine;
                }
            }
        }

        private void btnUpload_Click(object sender, EventArgs e)
        {
            int count = 0;
            string text = "";

            foreach (var item in richTextBox1.Text.Split('\n'))
            {
                if (item.Trim() != "")
                {
                    try
                    {
                        FtpWebRequest ftp = (FtpWebRequest)FtpWebRequest.Create(txtFtp.Text + "/" + Path.GetFileName(item));
                        ftp.Method = WebRequestMethods.Ftp.UploadFile;
                        ftp.Credentials = new NetworkCredential(txtUsername.Text, txtPassword.Text);

                        if (File.Exists(item))
                        {
                            FileStream file = File.OpenRead(item);
                            byte[] buffer = new byte[file.Length];
                            file.Read(buffer, 0, buffer.Length);
                            file.Close();

                            Stream request = ftp.GetRequestStream();
                            request.Write(buffer, 0, buffer.Length);
                            request.Close();
                        }
                        else
                        {
                            WebClient client = new WebClient();
                            string path = Path.GetTempPath() + "\\" + Path.GetFileName(item);
                            client.DownloadFile(new Uri(item), path);

                            FileStream file = File.OpenRead(path);
                            byte[] buffer = new byte[file.Length];
                            file.Read(buffer, 0, buffer.Length);
                            file.Close();

                            Stream request = ftp.GetRequestStream();
                            request.Write(buffer, 0, buffer.Length);
                            request.Close();

                            File.Delete(path);
                        }

                        count++;
                    }
                    catch
                    {
                        text += item + Environment.NewLine;
                    }
                }
            }
            richTextBox1.Text = text;
            MessageBox.Show("آپلود به پایان رسید" + "\nتعداد " + count.ToString() + " فایل با موفقیت آپلود شد ");
        }
    }
}
